clear all
clc

j = imread('c:\moon.jpg');
q = rgb2gray(j);

r = fspecial('gaussian',7,10);
i = imfilter(q,r,'replicate');

s = qtdecomp(i,.2);

blocks = repmat(uint8(0),size(s));

for dim = [512 256 128 64 32 16 8 4 2 1];    
  numblocks = length(find(s==dim));    
  if (numblocks > 0)        
    values = repmat(uint8(1),[dim dim numblocks]);
    values(2:dim,2:dim,:) = 0;
    blocks = qtsetblk(blocks,s,dim,values);
  end
end

blocks(end,1:end) = 1;
blocks(1:end,end) = 1;

subplot(2,2,1),imshow(j); title('Orignal Image');
subplot(2,2,2),imshow(i); title('After Filteration');
subplot(2,2,3),imshow(s); title('Sparse Representation');
subplot(2,2,4),imshow(blocks,[]); title('Quadtree Decomposition');